- Aldebaran documentation |
- C++ Libraries |
- index

libqi-api 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Namespace List
- Namespace Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Typedefs | Enumerations | Functions | Variables
qi::detail Namespace Reference

## Classes
struct | StaticAtomicInt
struct | Function
class | DelayedPromise
class | AddUnwrap< Future< T > >
struct | FutureWrapper
struct | FutureWrapper< void >
struct | FutureType
struct | FutureHasNoValue
struct | FutureType< void >
class | AddUnwrap
class | FutureBaseTyped
struct | VisitTimeout
class | FutureBase
class | FutureBarrierPrivate
struct | UnwrapImpl
struct | UnwrapImpl< T * >
struct | UnwrapImpl< boost::shared_ptr< T > >
struct | UnwrapImpl< boost::weak_ptr< T > >
struct | Unwrap
class | PrettyPrintStream
class | ParseablePrintStream
class | LockAndCall
struct | ObjectWrap
struct | ObjectWrap< T, false >
struct | ObjectWrap< T, true >
struct | IsAsyncBindImpl
struct | IsAsyncBind
struct | BindTransformImpl
struct | BindTransformImpl< T *, false >
struct | BindTransformImpl< T *, true >
struct | BindTransformImpl< boost::weak_ptr< T >, false >
struct | BindTransformImpl< boost::shared_ptr< T >, false >
struct | WorkaroundVS2015
struct | TerminateThread
class | Keeper
struct | Stranded
struct | StrandedUnwrapped
struct | Accessor
struct | AccessorBase
struct | Accessor< T C::*, typename boost::enable_if< typename boost::is_member_object_pointer< T C::* > >::type >
struct | Accessor< T &(C::*)()>
struct | Accessor< T &(C::*)() const >
struct | Accessor< T &(*)(C *)>
class | Class
struct | EqTypeBase
struct | EqTypeBase< T, true >
struct | EqType
struct | EqType< void >
struct | EqType< double >
struct | EqType< float >
struct | EqType< bool >
struct | EqType< T & >
struct | EqType< T const & >
struct | EqType< T * >
struct | RefMasqBuilderHelper
struct | RefMasqBuilderHelper< S, typename boost::mpl::end< S >::type, p >
struct | EqFunctionBare
struct | EqMemberFunction
struct | EqFunction
class | AnyReferenceCopy
struct | AssignAnyRef
struct | AssignAnyRef< T * >
struct | Ident
struct | checkForNonConstRef
struct | remove_constptr
struct | remove_constptr< const T * >
struct | fill_arguments
struct | FunctionPointerSynthetizer
struct | FunctionPointerSynthetizer< F, false >
struct | AnyFunctionMaker
struct | AnyFunctionMaker< T * >
struct | AnyFunctionMaker< boost::_bi::bind_t< R, F, B > >
struct | AnyFunctionMaker< boost::function< T > >
struct | AnyFunctionMaker< const T & >
struct | AnyFunctionMaker< AnyFunction >
struct | Pointer
struct | Pointer< T * >
class | AnyReferenceBase
struct | DeferOwnership
class | UniqueAnyReference
struct | TypeOfKind
struct | TypeOfKind< TypeKind_Int >
struct | TypeOfKind< TypeKind_Float >
struct | TypeOfKind< TypeKind_String >
class | ignore
struct | MappingItem
struct | IntFromMappingItem
struct | IntFromMappingItem< MappingItem< I, P > >
struct | ArgResolver
struct | ArgResolver< F, P, boost::_bi::value< V > >
struct | ArgResolver< F, P, boost::arg< I > >
struct | ArgLess
struct | ArgLess< A, MappingItem< I, B > >
struct | ArgLess< MappingItem< I, B >, A >
struct | ArgLess< MappingItem< I1, V1 >, MappingItem< I2, V2 > >
struct | MapItemIndexIs
struct | MapItemIndexIs< MappingItem< B, T >, boost::mpl::long_< B > >
struct | ReorderMapping
struct | ReorderMapping< 1, Map >
struct | ReorderMapping< 0, Map >
struct | MappingToType
struct | MappingToType< MappingItem< I, T > >
struct | MappingBuilder
struct | MappingBuilder< 0, F, V >
struct | parameter_types_from_bilist_seq
struct | BilistToSeq
struct | BilistToSeq< boost::_bi::list1< P1 > >
struct | BilistToSeq< boost::_bi::list2< P1, P2 > >
struct | BilistToSeq< boost::_bi::list3< P1, P2, P3 > >
struct | BilistToSeq< boost::_bi::list4< P1, P2, P3, P4 > >
struct | BilistToSeq< boost::_bi::list5< P1, P2, P3, P4, P5 > >
struct | parameter_types
struct | signature_function_arg_apply
struct | RawFunctionSignature
struct | RawFunctionSignature< boost::_bi::bind_t< R, F, B > >
struct | MemberFunctionSignature
struct | FunctionSignature
struct | FunctionSignature< boost::function< T > >
struct | isFuture
struct | isFuture< qi::Future< T > >
struct | isFuture< qi::FutureSync< T > >
struct | HasLessGuard
struct | HasLess
struct | HasLess< std::vector< T > >
struct | HasLess< std::list< T > >
struct | HasLess< std::map< K, V > >
struct | HasLess< std::pair< A, B > >
struct | HasLess< boost::optional< T > >
struct | HasLessSwitch
struct | HasLessSwitch< T, false >
struct | HasLessSwitch< T, true >
struct | LessHelper
struct | LessHelper< T, false >
struct | Less
struct | ForceProxyInclusion
class | GenericObjectBounce
struct | InterfaceImplTraits
struct | SigPropInheritsSignal
struct | SigPropInheritsProperty
struct | SigProp
struct | SigPropInheritsProperty< T, true >
struct | SigPropInheritsProperty< T, false >
struct | SigPropInheritsSignal< T, true >
struct | SigPropInheritsSignal< T, false >
struct | Dummy
class | BounceToSignalBase
struct | ObjectTypeData
class | StaticObjectTypeBase
struct | StructVersioningDelegateAddFields
struct | StructVersioningDelegateDropFields
struct | StructVersioningDelegate
struct | FieldInfo
class | AnyType
class | ForbiddenInTypeSystem
struct | TypeOfAdapter
struct | TypeOfAdapter< T & >
struct | TypeOfAdapter< const T >
struct | TypeOfAdapter< T * >
class | TypeImplMethodsBySize
struct | TypeTraitCreate
struct | TypeTraitCreate< T, false >
struct | TypeTraitCopy
struct | TypeTraitCopy< T, false >
struct | TypeTraitDestroy
struct | TypeTraitDestroy< T, false >
struct | TypeManagerDefaultStruct
struct | TypeManagerDefaultInterface
struct | TypeManagerNull
struct | TypeManagerNotConstructible
struct | TypeManager
struct | TypeManager< boost::function< T > >
struct | TypeManager< const T >
struct | TypeManager< Future< T > >
struct | TypeManager< FutureSync< T > >
struct | TypeManager< Promise< T > >

## Typedefs
template<typename T >
using | BindTransform = BindTransformImpl< typename std::decay< T >::type, std::is_base_of< TrackableBase, typename std::remove_pointer< typename std::decay< T >::type >::type >::value >
template<typename T >
using | remove_constptr_t = typename remove_constptr< T >::type
using | ManagedObjectPtr = boost::shared_ptr< GenericObject >
using | ProxyGeneratorMap = std::map< TypeInfo, boost::function< AnyReference(AnyObject)>>
using | FieldInfoVector = std::vector< FieldInfo >
using | TypeSignature = Signature
using | AnyTypeVector = std::vector< AnyType >
template<typename T >
using | TypeOfAdapter_t = typename TypeOfAdapter< T >::type
template<typename T >
using | TypeImplMethodsBySize_t = typename TypeImplMethodsBySize< T >::type

## Enumerations
enum | DisplayHiddenMembers : bool { DisplayHiddenMembers::Hide = false, DisplayHiddenMembers::Display = true }

## Functions
template<typename F >
auto | asyncMaybeActor (F &&cb, qi::Duration delay) -> typename std::enable_if< detail::IsAsyncBind< F >::value, typename std::decay< decltype(cb())>::type >::type
template<typename F >
auto | asyncMaybeActor (F &&cb, qi::SteadyClockTimePoint timepoint) -> typename std::enable_if< detail::IsAsyncBind< F >::value, typename std::decay< decltype(cb())>::type >::type
template<typename T >
void | newAndAssign (T **ptr)
void | printBuffer (std::ostream &stream, const Buffer &buffer)
template<typename F , typename Arg0 , typename... Args>
auto | invokeMaybeActor (F &&cb, Arg0 *arg0, Args &&...args) -> typename std::enable_if< std::is_base_of< Actor, typename std::decay< Arg0 >::type >::value, decltype(tryUnwrap(arg0->async(boost::bind(cb, arg0, std::forward< Args >(args)...)), 0))>::type
template<typename T >
void | tryCancel (Future< T > &fut, const char *errorMsg)
template<class Period >
void | write_duration_unit_long_name (std::ostream &os)
template<typename R >
void | setValue (qi::Promise< R > &p, const boost::function< R()> &f)
template<>
void | setValue< void > (qi::Promise< void > &p, const boost::function< void()> &f)
template<typename R >
void | callAndSet (qi::Promise< R > p, boost::function< R()> f)
template<typename R >
void | forwardError (qi::Future< void > f, qi::Promise< R > p)
template<typename R , typename F >
void | setPromiseFromCall (Promise< R > &p, F &&f)
template<typename F >
void | setPromiseFromCall (Promise< void > &p, F &&f)
template<typename R , typename F >
void | setPromiseFromCallWithExceptionSupport (Promise< R > &p, F &&f)
template<typename T >
void | waitForFirstHelper (qi::Promise< qi::Future< T > > &prom, qi::Future< T > &fut, qi::Atomic< int > *count)
template<typename FT , typename PT , typename CONV >
void | futureAdapter (const Future< FT > &f, Promise< PT > p, CONV converter)
template<typename FT >
void | futureCancelAdapter (boost::weak_ptr< FutureBaseTyped< FT > > wf)
template<typename FT >
void | futureCancelAdapter (boost::weak_ptr< detail::FutureBaseTyped< FT > > wf)
template<typename T >
T | tryUnwrap (T anything)
template<typename U >
Future< U > | tryUnwrap (Future< Future< U >> future)
template<typename T >
auto | tryUnwrap (T &&anything, int) -> decltype(tryUnwrap(std::forward< T >(anything)))
template<typename T >
T | defaultConstruct ()
template<>
void | defaultConstruct< void > ()
void | throwPointerLockException ()
po::options_description | getPerfOptions ()
void | addDomainPath (const std::string &path)
void | removeDomainPath (const std::string &path)
void | transformRef (void **args, void **out, unsigned int sz, unsigned long refMask)
template<typename T >
void | operator, (AnyReferenceCopy &g, T &&any)
template<typename F >
AnyFunction | makeAnyFunctionBare (F func)
template<typename C , typename R >
AnyReference | bouncer (const AnyReferenceVector &vargs, R(C::*fun)(const AnyArguments &))
template<typename R >
AnyReference | bouncerBF (const AnyReferenceVector &vargs, boost::function< R(const AnyArguments &)> f)
template<typename C , typename R >
AnyFunction | makeAnyFunctionBare (R(C::*fun)(const AnyArguments &))
template<typename R >
AnyFunction | makeAnyFunctionBare (R(*fun)(const AnyArguments &))
template<typename R >
AnyFunction | makeAnyFunctionBare (boost::function< R(const AnyArguments &)> fun)
template<typename F >
AnyFunction | makeAnyFunctionBare (boost::function< F > func)
template<typename T , TypeKind k>
T | valueAs (const AnyReferenceBase &v)
QI_NORETURN void | throwConversionFailure (TypeInterface *from, TypeInterface *to, const std::string &additionalMsg)
template<typename T >
qi::Signature | _functionArgumentsSignature ()
template<typename T >
qi::Signature | functionArgumentsSignature ()
template<typename T >
void | hold (T data)
template<typename T >
T | extractFuture (const qi::Future< qi::AnyReference > &metaFut)
template<typename T >
void | futureAdapter (const qi::Future< qi::AnyReference > &metaFut, qi::Promise< T > promise)
template<typename T >
void | futureAdapterVal (const qi::Future< qi::AnyValue > &metaFut, qi::Promise< T > promise)
template<typename T >
void | setPromise (qi::Promise< T > &promise, const AnyValue &v)
template<>
void | setPromise (qi::Promise< void > &promise, const AnyValue &)
template<>
void | setPromise (qi::Promise< AnyValue > &promise, const AnyValue &val)
template<>
void | setPromise (qi::Promise< AnyReference > &promise, const AnyValue &val)
template<typename T >
void | futureAdapterGeneric (AnyReference val, qi::Promise< T > promise, boost::shared_ptr< GenericObject > ao)
boost::shared_ptr< GenericObject > | getGenericFuture (AnyReference val, TypeKind *kind=0)
template<typename T >
bool | handleFuture (AnyReference val, Promise< T > promise)
template<>
void | extractFuture< void > (const qi::Future< qi::AnyReference > &metaFut)
template<typename T >
void | setAdaptedResult (Promise< T > &promise, UniqueAnyReference ref)
template<>
void | setAdaptedResult< void > (Promise< void > &promise, UniqueAnyReference ref)
template<>
void | setAdaptedResult< AnyReference > (Promise< AnyReference > &promise, UniqueAnyReference ref)
template<>
void | futureAdapterVal (const qi::Future< qi::AnyValue > &metaFut, qi::Promise< AnyValue > promise)
template<>
void | futureAdapterVal (const qi::Future< qi::AnyValue > &metaFut, qi::Promise< void > promise)
template<typename T , typename E >
void | pushBack (T &container, E *element)
template<typename CE , typename E >
void | pushBack (std::set< CE > &container, E *element)
ProxyGeneratorMap & | proxyGeneratorMap ()
template<typename T >
ManagedObjectPtr | managedObjectFromSharedPtr (ObjectTypeInterface *oit, boost::shared_ptr< T > other, const boost::optional< ObjectUid > &maybeUid=boost::none)
template<typename From >
ManagedObjectPtr | managedObjectFromSharedPtr (Object< Empty > &, boost::shared_ptr< From > &other, std::true_type)
template<typename From >
ManagedObjectPtr | managedObjectFromSharedPtr (Object< Empty > &, boost::shared_ptr< From > &other, std::false_type)
template<typename ToSameAsFrom >
ManagedObjectPtr | managedObjectFromSharedPtr (Object< ToSameAsFrom > &dst, boost::shared_ptr< ToSameAsFrom > &other, std::false_type)
template<typename To , typename From >
ManagedObjectPtr | managedObjectFromSharedPtr (Object< To > &dst, boost::shared_ptr< From > &other, std::false_type)
template<typename To , typename From >
ManagedObjectPtr | managedObjectFromSharedPtr (Object< To > &, boost::shared_ptr< From > &other, std::true_type)
template<typename T >
qi::Strand * | callWithVoid (qi::Strand *(T::*member)() const, void *instance)
template<typename T >
boost::enable_if < boost::is_base_of< Actor, T > , AnyFunction >::type | getStrandAccessor ()
template<typename T >
boost::disable_if < boost::is_base_of< Actor, T > , AnyFunction >::type | getStrandAccessor ()
template<typename F , typename T >
void | checkRegisterParent (ObjectTypeBuilder< T > &, boost::false_type)
template<typename F , typename T >
void | checkRegisterParent (ObjectTypeBuilder< T > &builder, boost::true_type)
template<typename A >
unsigned int | advertise (ObjectTypeBuilderBase *builder, const std::string &name, A accessor, Dummy< 0 >)
template<typename A >
unsigned int | advertise (ObjectTypeBuilderBase *builder, const std::string &name, A accessor, Dummy< 1 >)
template<typename A >
unsigned int | advertise (ObjectTypeBuilderBase *builder, const std::string &name, A accessor, Dummy< 2 >)
template<typename A >
unsigned int | advertiseBounce (ObjectTypeBuilderBase *builder, const std::string &name, A accessor, boost::true_type)
template<typename A >
unsigned int | advertiseBounce (ObjectTypeBuilderBase *builder, const std::string &name, A accessor, boost::false_type)
template<typename ProxyImpl >
Proxy * | static_proxy_cast (void *storage)
template<class InterfaceType , typename ProxyImpl >
TypeProxy< InterfaceType, ProxyImpl > * | makeProxyInterface ()
template<typename ProxyImpl >
AnyReference | makeProxy (AnyObject ptr)
bool | fillMissingFieldsWithDefaultValues (std::map< std::string,::qi::AnyValue > &fields, const std::vector< std::tuple< std::string, TypeInterface * >> &missing, const char **which=0, int whichLength=0)
std::string | normalizeClassName (const std::string &name)
template<typename T >
void | setFromStorage (T &ref, void *storage)
template<typename A >
TypeInterface * | fieldType (A)
template<typename C , typename A >
void * | fieldStorage (C *inst, A accessor)
template<typename C , typename A >
detail::Accessor< A >::value_type & | fieldValue (C *instance, A accessor, void **data)
AnyType | makeTypeOf (TypeKind kind)
AnyType | makeTypeList (const AnyType &element)
AnyType | makeTypeMap (const AnyType &key, const AnyType &element)
AnyType | makeTypeTuple (const AnyTypeVector &elements)
template<typename T >
void | initializeType (TypeInterface *&tgt)
template<typename T >
TypeInterface * | typeOfBackend ()
void | typeFail (const char *typeName, const char *operation)
| Report a type operation failure. More...
void | printMetaObject (std::ostream &stream, const qi::MetaObject &metaObject, bool color=true, bool showHidden=false, bool showDoc=false, bool raw=false, bool parseable=false)
struct | QI_API_DEPRECATED_MSG (Use 'QI_TYPE_ENUM'instead) QI_TYPE_ENUM_REGISTER_

## Variables
const std::size_t | maxAnyFunctionArgsCountHint = 8u

## Detailed Description

Traits and functions to factor code taking any accessor as argument. Supports member function, member object, and free-function

## Typedef Documentation

using qi::detail::AnyTypeVector = typedef std::vector<AnyType>

Definition at line 37 of file type.hpp.

template<typename T >

using qi::detail::BindTransform = typedef BindTransformImpl<typename std::decay<T>::type, std::is_base_of<TrackableBase, typename std::remove_pointer<typename std::decay<T>::type>::type>::value>

Definition at line 280 of file trackable.hxx.

using qi::detail::FieldInfoVector = typedef std::vector<FieldInfo>

Definition at line 32 of file type.hpp.

using qi::detail::ManagedObjectPtr = typedef boost::shared_ptr<GenericObject>

Definition at line 162 of file genericobject.hpp.

using qi::detail::ProxyGeneratorMap = typedef std::map<TypeInfo, boost::function<AnyReference(AnyObject)>>

Definition at line 38 of file object.hxx.

template<typename T >

using qi::detail::remove_constptr_t = typedef typename remove_constptr<T>::type

Definition at line 467 of file anyfunctionfactory.hxx.

template<typename T >

using qi::detail::TypeImplMethodsBySize_t = typedef typename TypeImplMethodsBySize<T>::type

Definition at line 130 of file type.hxx.

template<typename T >

using qi::detail::TypeOfAdapter_t = typedef typename TypeOfAdapter<T>::type

Definition at line 71 of file type.hxx.

using qi::detail::TypeSignature = typedef Signature

Definition at line 34 of file type.hpp.

## Enumeration Type Documentation

enum qi::detail::DisplayHiddenMembers : bool
| strong

Enumerator
Hide |
Display |

Definition at line 35 of file print.hpp.

## Function Documentation

template<typename T >

qi::Signature qi::detail::_functionArgumentsSignature | ( |  | ) |
| inline

Definition at line 126 of file functionsignature.hxx.

void qi::detail::addDomainPath | ( | const std::string & | path | ) |

template<typename A >

unsigned int qi::detail::advertise | ( | ObjectTypeBuilderBase * | builder,
|  | const std::string & | name,
|  | A | accessor,
|  | Dummy< 0 > |
| ) |  |

Definition at line 241 of file objecttypebuilder.hxx.

template<typename A >

unsigned int qi::detail::advertise | ( | ObjectTypeBuilderBase * | builder,
|  | const std::string & | name,
|  | A | accessor,
|  | Dummy< 1 > |
| ) |  |

Definition at line 245 of file objecttypebuilder.hxx.

template<typename A >

unsigned int qi::detail::advertise | ( | ObjectTypeBuilderBase * | builder,
|  | const std::string & | name,
|  | A | accessor,
|  | Dummy< 2 > |
| ) |  |

Definition at line 252 of file objecttypebuilder.hxx.

template<typename A >

unsigned int qi::detail::advertiseBounce | ( | ObjectTypeBuilderBase * | builder,
|  | const std::string & | name,
|  | A | accessor,
|  | boost::true_type |
| ) |  |

Definition at line 259 of file objecttypebuilder.hxx.

template<typename A >

unsigned int qi::detail::advertiseBounce | ( | ObjectTypeBuilderBase * | builder,
|  | const std::string & | name,
|  | A | accessor,
|  | boost::false_type |
| ) |  |

Definition at line 264 of file objecttypebuilder.hxx.

template<typename F >

auto qi::detail::asyncMaybeActor | ( | F && | cb,
|  | qi::Duration | delay
| ) |  | -> typename std::enable_if<detail::IsAsyncBind<F>::value, typename std::decay<decltype(cb())>::type>::type
| inline

Definition at line 18 of file async.hxx.

template<typename F >

auto qi::detail::asyncMaybeActor | ( | F && | cb,
|  | qi::SteadyClockTimePoint | timepoint
| ) |  | -> typename std::enable_if<detail::IsAsyncBind<F>::value, typename std::decay<decltype(cb())>::type>::type
| inline

Definition at line 36 of file async.hxx.

template<typename C , typename R >

AnyReference qi::detail::bouncer | ( | const AnyReferenceVector & | vargs,
|  | R(C::*)(const AnyArguments &) | fun
| ) |  |

Definition at line 525 of file anyfunctionfactory.hxx.

template<typename R >

AnyReference qi::detail::bouncerBF | ( | const AnyReferenceVector & | vargs,
|  | boost::function< R(const AnyArguments &)> | f
| ) |  |

Definition at line 544 of file anyfunctionfactory.hxx.

template<typename R >

void qi::detail::callAndSet | ( | qi::Promise< R > | p,
|  | boost::function< R()> | f
| ) |  |

Definition at line 161 of file executioncontext.hpp.

template<typename T >

qi::Strand* qi::detail::callWithVoid | ( | qi::Strand *(T::*)() const | member,
|  | void * | instance
| ) |  |

Definition at line 20 of file objecttypebuilder.hxx.

template<typename F , typename T >

void qi::detail::checkRegisterParent | ( | ObjectTypeBuilder< T > & | ,
|  | boost::false_type |
| ) |  |

Definition at line 107 of file objecttypebuilder.hxx.

template<typename F , typename T >

void qi::detail::checkRegisterParent | ( | ObjectTypeBuilder< T > & | builder,
|  | boost::true_type |
| ) |  |

Definition at line 109 of file objecttypebuilder.hxx.

template<typename T >

T qi::detail::defaultConstruct | ( |  | ) |

Definition at line 84 of file trackable.hxx.

template<>

void qi::detail::defaultConstruct< void > | ( |  | ) |
| inline

Definition at line 90 of file trackable.hxx.

template<typename T >

T qi::detail::extractFuture | ( | const qi::Future< qi::AnyReference > & | metaFut | ) |
| inline

Definition at line 189 of file futureadapter.hxx.

template<>

void qi::detail::extractFuture< void > | ( | const qi::Future< qi::AnyReference > & | metaFut | ) |
| inline

Definition at line 224 of file futureadapter.hxx.

template<typename C , typename A >

void* qi::detail::fieldStorage | ( | C * | inst,
|  | A | accessor
| ) |  |

Definition at line 198 of file structtypeinterface.hxx.

template<typename A >

TypeInterface* qi::detail::fieldType | ( | A |  | ) |

Definition at line 191 of file structtypeinterface.hxx.

template<typename C , typename A >

detail::Accessor<A>::value_type& qi::detail::fieldValue | ( | C * | instance,
|  | A | accessor,
|  | void ** | data
| ) |  |

Definition at line 206 of file structtypeinterface.hxx.

bool qi::detail::fillMissingFieldsWithDefaultValues | ( | std::map< std::string,::qi::AnyValue > & | fields,
|  | const std::vector< std::tuple< std::string, TypeInterface * >> & | missing,
|  | const char ** | which = `0`,
|  | int | whichLength = `0`
| ) |  |

template<typename R >

void qi::detail::forwardError | ( | qi::Future< void > | f,
|  | qi::Promise< R > | p
| ) |  |

Definition at line 177 of file executioncontext.hpp.

template<typename T >

qi::Signature qi::detail::functionArgumentsSignature | ( |  | ) |
| inline

Definition at line 140 of file functionsignature.hxx.

template<typename T >

void qi::detail::futureAdapter | ( | const qi::Future< qi::AnyReference > & | metaFut,
|  | qi::Promise< T > | promise
| ) |  |
| inline

Definition at line 305 of file futureadapter.hxx.

template<typename FT , typename PT , typename CONV >

void qi::detail::futureAdapter | ( | const Future< FT > & | f,
|  | Promise< PT > | p,
|  | CONV | converter
| ) |  |

Definition at line 475 of file future.hxx.

template<typename T >

void qi::detail::futureAdapterGeneric | ( | AnyReference | val,
|  | qi::Promise< T > | promise,
|  | boost::shared_ptr< GenericObject > | ao
| ) |  |

Definition at line 59 of file futureadapter.hxx.

template<typename T >

void qi::detail::futureAdapterVal | ( | const qi::Future< qi::AnyValue > & | metaFut,
|  | qi::Promise< T > | promise
| ) |  |
| inline

Definition at line 324 of file futureadapter.hxx.

template<>

void qi::detail::futureAdapterVal | ( | const qi::Future< qi::AnyValue > & | metaFut,
|  | qi::Promise< AnyValue > | promise
| ) |  |
| inline

Definition at line 353 of file futureadapter.hxx.

template<>

void qi::detail::futureAdapterVal | ( | const qi::Future< qi::AnyValue > & | metaFut,
|  | qi::Promise< void > | promise
| ) |  |
| inline

Definition at line 364 of file futureadapter.hxx.

template<typename FT >

void qi::detail::futureCancelAdapter | ( | boost::weak_ptr< detail::FutureBaseTyped< FT > > | wf | ) |

template<typename FT >

void qi::detail::futureCancelAdapter | ( | boost::weak_ptr< FutureBaseTyped< FT > > | wf | ) |

Definition at line 496 of file future.hxx.

boost::shared_ptr<GenericObject> qi::detail::getGenericFuture | ( | AnyReference | val,
|  | TypeKind * | kind = `0`
| ) |  |
| inline

Definition at line 105 of file futureadapter.hxx.

po::options_description qi::detail::getPerfOptions | ( |  | ) |
| inline

Definition at line 18 of file dataperfsuite.hxx.

template<typename T >

boost::enable_if<boost::is_base_of<Actor, T>, AnyFunction>::type qi::detail::getStrandAccessor | ( |  | ) |

Definition at line 27 of file objecttypebuilder.hxx.

template<typename T >

boost::disable_if<boost::is_base_of<Actor, T>, AnyFunction>::type qi::detail::getStrandAccessor | ( |  | ) |

Definition at line 34 of file objecttypebuilder.hxx.

template<typename T >

bool qi::detail::handleFuture | ( | AnyReference | val,
|  | Promise< T > | promise
| ) |  |
| inline

Definition at line 138 of file futureadapter.hxx.

template<typename T >

void qi::detail::hold | ( | T | data | ) |

Definition at line 18 of file futureadapter.hpp.

template<typename T >

void qi::detail::initializeType | ( | TypeInterface *& | tgt | ) |
| inline

Definition at line 44 of file type.hxx.

template<typename F , typename Arg0 , typename... Args>

auto qi::detail::invokeMaybeActor | ( | F && | cb,
|  | Arg0 * | arg0,
|  | Args &&... | args
| ) |  | -> typename std::enable_if<std::is_base_of<Actor, typename std::decay<Arg0>::type>::value, decltype(tryUnwrap(arg0->async(boost::bind(cb, arg0, std::forward<Args>(args)...)), 0))>::type

Definition at line 53 of file async.hxx.

template<typename F >

AnyFunction qi::detail::makeAnyFunctionBare | ( | F | func | ) |

Definition at line 498 of file anyfunctionfactory.hxx.

template<typename C , typename R >

AnyFunction qi::detail::makeAnyFunctionBare | ( | R(C::*)(const AnyArguments &) | fun | ) |

Definition at line 562 of file anyfunctionfactory.hxx.

template<typename R >

AnyFunction qi::detail::makeAnyFunctionBare | ( | R(*)(const AnyArguments &) | fun | ) |

Definition at line 571 of file anyfunctionfactory.hxx.

template<typename R >

AnyFunction qi::detail::makeAnyFunctionBare | ( | boost::function< R(const AnyArguments &)> | fun | ) |

Definition at line 580 of file anyfunctionfactory.hxx.

template<typename F >

AnyFunction qi::detail::makeAnyFunctionBare | ( | boost::function< F > | func | ) |

Definition at line 588 of file anyfunctionfactory.hxx.

template<typename ProxyImpl >

AnyReference qi::detail::makeProxy | ( | AnyObject | ptr | ) |

Definition at line 136 of file proxyregister.hpp.

template<class InterfaceType , typename ProxyImpl >

TypeProxy<InterfaceType, ProxyImpl>* qi::detail::makeProxyInterface | ( |  | ) |

Definition at line 127 of file proxyregister.hpp.

AnyType qi::detail::makeTypeList | ( | const AnyType & | element | ) |

AnyType qi::detail::makeTypeMap | ( | const AnyType & | key,
|  | const AnyType & | element
| ) |  |

AnyType qi::detail::makeTypeOf | ( | TypeKind | kind | ) |

AnyType qi::detail::makeTypeTuple | ( | const AnyTypeVector & | elements | ) |

template<typename T >

ManagedObjectPtr qi::detail::managedObjectFromSharedPtr | ( | ObjectTypeInterface * | oit,
|  | boost::shared_ptr< T > | other,
|  | const boost::optional< ObjectUid > & | maybeUid = `boost::none`
| ) |  |

Definition at line 444 of file object.hxx.

template<typename From >

ManagedObjectPtr qi::detail::managedObjectFromSharedPtr | ( | Object< Empty > & | ,
|  | boost::shared_ptr< From > & | other,
|  | std::true_type |
| ) |  |

Definition at line 459 of file object.hxx.

template<typename From >

ManagedObjectPtr qi::detail::managedObjectFromSharedPtr | ( | Object< Empty > & | ,
|  | boost::shared_ptr< From > & | other,
|  | std::false_type |
| ) |  |

Definition at line 469 of file object.hxx.

template<typename ToSameAsFrom >

ManagedObjectPtr qi::detail::managedObjectFromSharedPtr | ( | Object< ToSameAsFrom > & | dst,
|  | boost::shared_ptr< ToSameAsFrom > & | other,
|  | std::false_type |
| ) |  |

Definition at line 479 of file object.hxx.

template<typename To , typename From >

ManagedObjectPtr qi::detail::managedObjectFromSharedPtr | ( | Object< To > & | dst,
|  | boost::shared_ptr< From > & | other,
|  | std::false_type |
| ) |  |

Definition at line 489 of file object.hxx.

template<typename To , typename From >

ManagedObjectPtr qi::detail::managedObjectFromSharedPtr | ( | Object< To > & | ,
|  | boost::shared_ptr< From > & | other,
|  | std::true_type |
| ) |  |

Definition at line 503 of file object.hxx.

template<typename T >

void qi::detail::newAndAssign | ( | T ** | ptr | ) |

Definition at line 227 of file atomic.hpp.

std::string qi::detail::normalizeClassName | ( | const std::string & | name | ) |

template<typename T >

void qi::detail::operator, | ( | AnyReferenceCopy & | g,
|  | T && | any
| ) |  |

Definition at line 260 of file anyfunctionfactory.hxx.

void qi::detail::printBuffer | ( | std::ostream & | stream,
|  | const Buffer & | buffer
| ) |  |

void qi::detail::printMetaObject | ( | std::ostream & | stream,
|  | const qi::MetaObject & | metaObject,
|  | bool | color = `true`,
|  | bool | showHidden = `false`,
|  | bool | showDoc = `false`,
|  | bool | raw = `false`,
|  | bool | parseable = `false`
| ) |  |

ProxyGeneratorMap& qi::detail::proxyGeneratorMap | ( |  | ) |

template<typename T , typename E >

void qi::detail::pushBack | ( | T & | container,
|  | E * | element
| ) |  |

Definition at line 95 of file listtypeinterface.hxx.

template<typename CE , typename E >

void qi::detail::pushBack | ( | std::set< CE > & | container,
|  | E * | element
| ) |  |

Definition at line 100 of file listtypeinterface.hxx.

struct qi::detail::QI_API_DEPRECATED_MSG | ( | Use 'QI_TYPE_ENUM' | instead | ) |

Definition at line 411 of file typeinterface.hpp.

void qi::detail::removeDomainPath | ( | const std::string & | path | ) |

template<typename T >

void qi::detail::setAdaptedResult | ( | Promise< T > & | promise,
|  | UniqueAnyReference | ref
| ) |  |
| inline

Factorization of the setting of the promise according to the future result. This method takes ownership of the reference.

Definition at line 242 of file futureadapter.hxx.

template<>

void qi::detail::setAdaptedResult< AnyReference > | ( | Promise< AnyReference > & | promise,
|  | UniqueAnyReference | ref
| ) |  |
| inline

Specialization for setting the promise according to the future result in the case of AnyReference. This method takes ownership of the reference.

Definition at line 286 of file futureadapter.hxx.

template<>

void qi::detail::setAdaptedResult< void > | ( | Promise< void > & | promise,
|  | UniqueAnyReference | ref
| ) |  |
| inline

Specialization for setting the promise according to the future result in the case of void. This method takes ownership of the reference.

Definition at line 272 of file futureadapter.hxx.

template<typename T >

void qi::detail::setFromStorage | ( | T & | ref,
|  | void * | storage
| ) |  |

Definition at line 184 of file structtypeinterface.hxx.

template<typename T >

void qi::detail::setPromise | ( | qi::Promise< T > & | promise,
|  | const AnyValue & | v
| ) |  |

Definition at line 20 of file futureadapter.hxx.

template<>

void qi::detail::setPromise | ( | qi::Promise< void > & | promise,
|  | const AnyValue & |
| ) |  |
| inline

Definition at line 43 of file futureadapter.hxx.

template<>

void qi::detail::setPromise | ( | qi::Promise< AnyValue > & | promise,
|  | const AnyValue & | val
| ) |  |
| inline

Definition at line 48 of file futureadapter.hxx.

template<>

void qi::detail::setPromise | ( | qi::Promise< AnyReference > & | promise,
|  | const AnyValue & | val
| ) |  |
| inline

Definition at line 53 of file futureadapter.hxx.

template<typename R , typename F >

void qi::detail::setPromiseFromCall | ( | Promise< R > & | p,
|  | F && | f
| ) |  |

Definition at line 23 of file future.hxx.

template<typename F >

void qi::detail::setPromiseFromCall | ( | Promise< void > & | p,
|  | F && | f
| ) |  |

Definition at line 32 of file future.hxx.

template<typename R , typename F >

void qi::detail::setPromiseFromCallWithExceptionSupport | ( | Promise< R > & | p,
|  | F && | f
| ) |  |

Definition at line 39 of file future.hxx.

template<typename R >

void qi::detail::setValue | ( | qi::Promise< R > & | p,
|  | const boost::function< R()> & | f
| ) |  |

Definition at line 148 of file executioncontext.hpp.

template<>

void qi::detail::setValue< void > | ( | qi::Promise< void > & | p,
|  | const boost::function< void()> & | f
| ) |  |
| inline

Definition at line 154 of file executioncontext.hpp.

template<typename ProxyImpl >

Proxy* qi::detail::static_proxy_cast | ( | void * | storage | ) |

Definition at line 121 of file proxyregister.hpp.

QI_NORETURN void qi::detail::throwConversionFailure | ( | TypeInterface * | from,
|  | TypeInterface * | to,
|  | const std::string & | additionalMsg
| ) |  |

void qi::detail::throwPointerLockException | ( |  | ) |
| inline

Definition at line 282 of file trackable.hxx.

void qi::detail::transformRef | ( | void ** | args,
|  | void ** | out,
|  | unsigned int | sz,
|  | unsigned long | refMask
| ) |  |
| inline

Definition at line 212 of file anyfunctionfactory.hxx.

template<typename T >

void qi::detail::tryCancel | ( | Future< T > & | fut,
|  | const char * | errorMsg
| ) |  |

Definition at line 120 of file async.hxx.

template<typename T >

T qi::detail::tryUnwrap | ( | T | anything | ) |

Definition at line 19 of file futureunwrap.hpp.

template<typename U >

Future<U> qi::detail::tryUnwrap | ( | Future< Future< U >> | future | ) |

Definition at line 25 of file futureunwrap.hpp.

template<typename T >

auto qi::detail::tryUnwrap | ( | T && | anything,
|  | int |
| ) |  | -> decltype(tryUnwrap(std::forward<T>(anything)))

Definition at line 32 of file futureunwrap.hpp.

void qi::detail::typeFail | ( | const char * | typeName,
|  | const char * | operation
| ) |  |

Report a type operation failure.

template<typename T >

TypeInterface* qi::detail::typeOfBackend | ( |  | ) |
| inline

Definition at line 51 of file type.hxx.

template<typename T , TypeKind k>

T qi::detail::valueAs | ( | const AnyReferenceBase & | v | ) |
| inline

Definition at line 100 of file anyreference.hxx.

template<typename T >

void qi::detail::waitForFirstHelper | ( | qi::Promise< qi::Future< T > > & | prom,
|  | qi::Future< T > & | fut,
|  | qi::Atomic< int > * | count
| ) |  |

Definition at line 389 of file future.hxx.

template<class Period >

void qi::detail::write_duration_unit_long_name | ( | std::ostream & | os | ) |

## Variable Documentation

const std::size_t qi::detail::maxAnyFunctionArgsCountHint = 8u

Definition at line 289 of file anyfunction.hpp.